#ifndef DIJK_PLANNER_H
#define DIJK_PLANNER_H
#include <my_global_planner/gradient_path.h>

#include "stdint.h"
#include <cmath>

#define PREV_UNDEFINED  0
#define XY_TO_INDEX(x,y)   ((x) + (Size_X) * (y))
#define SQRT2           1.414
#define COST_FACTOR     1


namespace my_global_planner
{
  class DijkPlanner
    {
    public:
     DijkPlanner(costmap_2d::Costmap2D* costmap);
     ~DijkPlanner();

     void DrawMapOutLine(unsigned char* costarr, int nx, int ny, unsigned char value);
     bool Alogrithim_OnCostMap(unsigned int start_X,unsigned int start_Y,unsigned int goal_X,unsigned int goal_Y);
     bool global_path_seek(float start_X,float start_Y,float goal_X,float goal_Y,std::vector<std::pair<float, float> >& path);
     bool PathConstruct(unsigned int start_X,unsigned int start_Y,unsigned int goal_X,unsigned int goal_Y,std::vector<std::pair<float, float> >& path);
     float QuadraticCalculate_cost_dist(const float * Node_cost_dist,unsigned char cell_cost,unsigned int NextIndex,unsigned int& index);
     float* Node_cost_dist;

     GradientPath* gradientConstruct;
     bool use_gradient_construct_;

    private:
      unsigned int Size_X;
      unsigned int Size_Y;


      unsigned int* PrevNode;
      bool* NodeIsVisted;
      unsigned char* CostmapIndexArray;

      unsigned int NodesCount;

      unsigned char lethal_cost_;

  };
};

 #endif
