#include "my_global_planner/global_planner.h"

namespace my_global_planner {

void MyGlobalPlanner::mapToWorld(double map_x, double map_y, double& world_x, double& world_y)
{
    world_x = costmap_->getOriginX() +  map_x * costmap_->getResolution();
    world_y = costmap_->getOriginY() +  map_y * costmap_->getResolution();
}

bool MyGlobalPlanner::worldToMap(double world_x, double world_y, double& map_x, double& map_y)
{
    double origin_x = costmap_->getOriginX(), origin_y = costmap_->getOriginY();
    double resolution = costmap_->getResolution();

    if (world_x < origin_x || world_y < origin_y)
    {
      return false;
    }

    map_x = (world_x - origin_x) / resolution;
    map_y = (world_y - origin_y) / resolution;

    if (map_x < costmap_->getSizeInCellsX() && map_y < costmap_->getSizeInCellsY())
    {
      return true;
    }

    return false;
}


};
