#include "ros/ros.h"
#include "send_goal/AddTwoInts.h" 
#include <fstream>
#include <iostream>
#include <stdio.h>
#include <string.h>
#include <unistd.h>  
#include <cstdlib>
using namespace std;

float EndPointXY[8][2] = {
	{15.4  ,-6.88},
	{15.574,-6.415},
	{15.686,-5.9052},
	{15.791,-5.3904},
	{16.003,-4.852},
	{16.019,-4.3814},
	{16.086, -3.9273},
	{16.186,-3.4718},
	};

float MedPointXY[8][2] = {
  {2.31,   0.32},
	{4.55,   0.066},
	{3.78,    -2.49},
	{5.26,    -4.23},
	{13.34,    -2.62},
	{11.09,    -2.91},
	{11.76,    -0.63},
	{10.43,    1.35},
};


void productListYaml(int routeID,int EndPointID)
{
  routeID -= 1;
  EndPointID -= 1;

  ofstream outfile;
  outfile.open("/home/ubuntu/auto_car/list.yaml");
  char arg[300]="/home/ubuntu/auto_car/run.sh";

  outfile << "%YAML:1.0" << endl;
	outfile << "features:" << endl;
	outfile << " - {x:"<<MedPointXY[routeID][0]<<",   y:"<<MedPointXY[routeID][1]<<"}" << endl;
	outfile << " - {x:"<<MedPointXY[routeID + 4][0]<<",   y:"<<MedPointXY[routeID + 4][1]<<"}" << endl;
	outfile << " - {x:" << EndPointXY[EndPointID][0] << ",   y:" << EndPointXY[EndPointID][1] << "}" << endl;
  outfile << " - {x:"<<MedPointXY[routeID + 4][0]<<",   y:"<<MedPointXY[routeID + 4][1]<<"}" << endl;
  outfile << " - {x:"<<MedPointXY[routeID][0]<<",   y:"<<MedPointXY[routeID][1]<<"}" << endl;
  outfile << " - {x:-0.12361,      y:1.3092}" << endl;
  outfile.close();
  system(arg);
}



bool  run(send_goal::AddTwoInts::Request  &req,
	 send_goal::AddTwoInts::Response &res)
{
  //res.sum = req.a + req.b;
  //ROS_INFO("request: x=%ld, y=%ld", (long int)req.a, (long int)req.b);
  //ROS_INFO("sending back response: [%ld]", (long int)res.sum);
  ofstream outfile;
  outfile.open("/home/ubuntu/auto_car/list.yaml");
char arg[300]="/home/ubuntu/auto_car/run.sh";
float p[8][2] = {
	{15.4  ,-6.88},
	{15.574,-6.415},
	{15.686,-5.9052},
	{15.791,-5.3904},
	{16.003,-4.852},
	{16.019,-4.3814},
	{16.086, -3.9273},
	{16.186,-3.4718},
	};

  if(req.b == 8)
	{
	   switch(req.a){
			case 1:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:2.31,   y:-0.32}" << endl;
				outfile << " - {x:13.34,    y:-2.62}" << endl;
                                outfile << " - {x:" << p[7][0] << ",   y:" << p[7][1] << "}" << endl;
				outfile << " - {x:" << p[0][0] << ",   y:" << p[0][1] << "}" << endl;
				outfile << " - {x:13.34,    y:-2.62}" << endl;
				outfile << " - {x:2.31,   y:-0.32}" << endl;
				break;
			case 2:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:4.55,   y:0.066}" << endl;
				outfile << " - {x:11.09,    y:-2.91}" << endl;
				outfile << " - {x:" << p[7][0] << ",   y:" << p[7][1] << "}" << endl;
				outfile << " - {x:" << p[0][0] << ",   y:" << p[0][1] << "}" << endl;
				outfile << " - {x:11.09,    y:-2.91}" << endl;
				outfile << " - {x:4.45,   y:0.066}" << endl;
				break;
			case 3:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:3.78,    y:-2.49}" << endl;		
				outfile << " - {x:11.76,    y:-0.63}" << endl;		
				outfile << " - {x:" << p[7][0] << ",   y:" << p[7][1] << "}" << endl;
				outfile << " - {x:" << p[0][0] << ",   y:" << p[0][1] << "}" << endl;
				outfile << " - {x:11.76,    y:-0.63}" << endl;
				outfile << " - {x:3.78,    y:-2.49}" << endl;
				break;
			case 4:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:5.26,    y:-4.23}" << endl;
				outfile << " - {x:10.43,    y:1.35}" << endl;
				outfile << " - {x:" << p[7][0] << ",   y:" << p[7][1] << "}" << endl;
				outfile << " - {x:" << p[0][0] << ",   y:" << p[0][1] << "}" << endl;
				outfile << " - {x:10.43,    y:1.35}" << endl;
				outfile << " - {x:5.26,    y:-4.23}" << endl;
				break;
			default:
				cout << "Wrong input!" << endl;
				outfile.close(); 
                                 break;
                }
	} 
	else
	{
		switch(req.a){
			case 1:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:2.31,   y:-0.32}" << endl;
				outfile << " - {x:13.34,    y:-2.62}" << endl;
				outfile << " - {x:" << p[req.b-1][0] << ",   y:" << p[req.b-1][1] << "}" << endl;
				outfile << " - {x:13.34,    y:-2.62}" << endl;
				outfile << " - {x:2.31,   y:-0.32}" << endl;
				break;
			case 2:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:4.55,   y:0.066}" << endl;
				outfile << " - {x:11.09,    y:-2.91}" << endl;
				outfile << " - {x:" << p[req.b-1][0] << ",   y:" << p[req.b-1][1] << "}" << endl;
				outfile << " - {x:11.09,    y:-2.91}" << endl;
				outfile << " - {x:4.45,   y:0.066}" << endl;
				break;
			case 3:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:3.78,    y:-2.49}" << endl;		
				outfile << " - {x:11.76,    y:-0.63}" << endl;		
				outfile << " - {x:" << p[req.b-1][0] << ",   y:" << p[req.b-1][1] << "}" << endl;
				outfile << " - {x:11.76,    y:-0.63}" << endl;
				outfile << " - {x:3.78,    y:-2.49}" << endl;
				break;
			case 4:
				outfile << "%YAML:1.0" << endl;
				outfile << "features:" << endl;
				outfile << " - {x:5.26,    y:-4.23}" << endl;
				outfile << " - {x:10.43,    y:1.35}" << endl;
				outfile << " - {x:" << p[req.b-1][0] << ",   y:" << p[req.b-1][1] << "}" << endl;
				outfile << " - {x:10.43,    y:1.35}" << endl;
				outfile << " - {x:5.26,    y:-4.23}" << endl;
				break;
			default:
				cout << "Wrong input!" << endl;
				outfile.close();
                                 break;
		
		}
          } 


  
outfile << " - {x:-0.12361,      y:1.3092}" << endl;
//outfile << " - {x:-0.12,    y:1.7}" << endl;
outfile.close();
system(arg);

  return true;
}

int main(int argc, char **argv)
{
    std::cout<<argc<<"    "<<argv[0]<<"   "<<argv[1]  <<std::endl;
  ros::init(argc, argv, "task1");
  ros::NodeHandle n;
  int routeID = 0;
  int  EndPointID = 0;
  if(argc == 3)
  {
    routeID = argv[1][0] - '0';
    EndPointID = argv[2][0] - '0';
  }
 cout<<routeID <<"   "<<EndPointID<<endl; 
  if(routeID > 4 || EndPointID >8)
  {
      routeID = 0;
      EndPointID = 0;
  }
  if(routeID ==  0|| EndPointID == 0)
  {
    ros::ServiceServer service = n.advertiseService("add_two_ints", run);
  }
  else
  {
		productListYaml(routeID,EndPointID);
  }
    ROS_INFO("Ready to move~");
  ros::spin();
  
  return 0;
}
