#ifndef COMMREAD_H
#define COMMREAD_H
#include <serial_comm/shootdata.h>
#include <serial_comm/car_speed.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <sys/types.h>
#include <sys/stat.h>
#include <memory>
#include <vector>
#include <string>
#include <math.h>
#include <fcntl.h>      /*file control lib*/
#include <termios.h>    /*PPSIX terminal*/
#include <errno.h>      /*error information*/
#include <stdlib.h>     /*standard lib*/
#include <unistd.h>     /*Unix standard func*/

namespace autocar
{
namespace serial_mul
{
typedef struct
{
  uint8_t sof;
  int16_t angle;
  int16_t v_w;
  int16_t v_x;
  int16_t v_y;


  uint8_t flag;
  float x;
  float y;
  float z;
  float compass;
  uint8_t data_status;

  float pan_title_yaw;
  float pan_title_pitch;
  int16_t blood;
  //uint8_t armor_hited;
  uint8_t end;
}__attribute__((packed)) data_t;

class comm_read{
public:
  comm_read(const std::string& devel);
  ~comm_read();
  /**
   * @brief Initialization the serial paramters for reading data
   * @return
   */
  bool read_setup();
  /**
   * @brief initialization the yaw angle
   */
  void read_init();
  /**
   * @brief reading data from serial
   */
  void read_data();
public:
  bool CarDataUpdated = false;
  bool If_yaw_inited = false;
  serial_comm::car_speed pubData;
  serial_comm::shootdata shoot_data;
private:
  std::string dev;
  int serial_baudrate;
  int fd;
  int data_len;
  int16_t ForeBack, LeftRight, Y, R;
  double YawAngle, Rotate;
  int16_t init_yaw = 0;
  data_t data;

  uint16_t HeadIndex = 0;
  uint16_t BufferIndex = 0;

  void FrameConstruct();
  void Frame_read();
  uint8_t buff[256*3];
};

}
}
#endif // COMMREAD_H
