#include "ros/ros.h"
#include <std_msgs/String.h>
#include "comm_read.h"

#include <tf/transform_broadcaster.h>
#include <nav_msgs/Odometry.h>

int main(int argc, char *argv[])
{
  ros::init(argc, argv, "serialRead");
  ros::NodeHandle nh;
  ros::Publisher publisher;
  ros::Publisher shootPub;
  publisher = nh.advertise<serial_comm::car_speed>("car_info", 10);
  shootPub  = nh.advertise<serial_comm::shootdata>("shoot_info",10);
	ros::NodeHandle private_nh_("~");
	std::string dev;
        private_nh_.param("ttyUSBport", dev, std::string("/dev/car_cmd"));
  
  ROS_WARN("comm port used %s",dev.c_str());
  
	autocar::serial_mul::comm_read car_comm_read(dev);
	ros::Rate loopRate(50);

  //set up the serial
  bool sucess = car_comm_read.comm_read::read_setup();
  if (sucess == false)
  {
    perror("error!");
    return -1;
  }
  car_comm_read.read_init();

  while(nh.ok())
  {
    ros::spinOnce();
    loopRate.sleep();
    car_comm_read.read_data();
    if(car_comm_read.CarDataUpdated)
    {
         car_comm_read.CarDataUpdated = false;

          printf("YawAngle:  %f\n",car_comm_read.pubData.angle);
          printf("ForeBack:  %f\n",car_comm_read.pubData.v_x);
          printf("LeftRight: %f\n",car_comm_read.pubData.v_y);
          printf("Rotate:    %f\n",car_comm_read.pubData.v_r);
          printf("PanYaw:    %f\n",car_comm_read.pubData.yaw*(180/M_PI));
          printf("---------------------\n");
		 
		   publisher.publish(car_comm_read.pubData);
                   shootPub.publish(car_comm_read.shoot_data);

    }
  }
  return 0;
}
