#ifndef CV_BGR_H
#define CV_BGR_H

#include<ros/ros.h>
#include<iostream>
#include<cv_bridge/cv_bridge.h>
#include<sensor_msgs/image_encodings.h>
#include<geometry_msgs/PoseStamped.h>
#include<opencv2/core/core.hpp>
#include<opencv2/highgui/highgui.hpp>
#include<opencv2/imgproc/imgproc.hpp>
#include<image_transport/image_transport.h>
#include<cv_bgr/myCenter.h>
#include<tf/tf.h>

typedef struct
{
    int x;
    int y;
    float r;
}myCircle;

class CV_BGR
{
private:
    int width,height;
    int iLowH ;
    int iHighH ;
    int iLowS ;
    int iHighS ;
    int iLowV ;
    int iHighV ;
    int thresh;
    double fx;
    double fy;
    double cx;
    double cy; 
    double function_a;
    double function_b;
    bool getRect;
    bool show_img;
    myCircle img_ball;
    cv::Rect ballRect;
    cv_bgr::myCenter ball;
    geometry_msgs::PoseStamped tag_pose;
    //ros::NodeHandle nh_;
    //ros::geometry_msgs::PoseStamped  
  //  ros::Publisher tagcenter_pub_;
    ros::Publisher tag_pose_pub_;
    image_transport::ImageTransport it_;
    image_transport::Subscriber image_sub_;
    image_transport::Publisher image_pub_;
public:
    CV_BGR(ros::NodeHandle &nh_,ros::NodeHandle& pnh);
    ~CV_BGR();
    double tic();
    void convert_callback(const sensor_msgs::ImageConstPtr& msg);
    void image_show(cv::Mat &img);
    bool get_angle(cv::Mat src, cv::Rect rect);
    cv::Rect get_rect(cv::Mat img);
    cv::Mat find_ball(cv::Mat img, cv::Rect rect);


};

#endif // CV_BGR_H
