#ifndef FIND_APRON_H
#define FIND_APRON_H

#include<ros/ros.h>
#include<iostream>
#include<cv_bridge/cv_bridge.h>
#include<sensor_msgs/image_encodings.h>
#include<opencv2/core/core.hpp>
#include<opencv2/highgui/highgui.hpp>
#include<opencv2/imgproc/imgproc.hpp>
#include<image_transport/image_transport.h>
#include "find_apron/apron_center.h"
#include <geometry_msgs/PoseStamped.h>
#include <tf/tf.h>
typedef struct
{
    int x;
    int y;
    float r;
}myCircle;

class FIND_APRON
{
private:
    int width,height;
    int iLowH ;
    int iHighH ;
    int iLowS ;
    int iHighS ;
    int iLowV ;
    int iHighV ;
    int thread;
    double fx;
    double fy;
    double cx;
    double cy;
    double function_a;
    double function_b;
    bool show_img;
    bool redApron;
    bool getRect;
    cv::Rect ringRect;

    find_apron::apron_center ring;
    geometry_msgs::PoseStamped apron_pose;
    //ros::Publisher tagcenter_pub_;
    ros::Publisher apron_pose_pub_;
    image_transport::ImageTransport it_;
    image_transport::Subscriber image_sub_;
    image_transport::Publisher image_pub_;
public:
    FIND_APRON(ros::NodeHandle &nh_,ros::NodeHandle& pnh);
    ~FIND_APRON();
    double tic();
    void convert_callback(const sensor_msgs::ImageConstPtr& msg);
    void image_show(cv::Mat &img);
    cv::Rect get_rect(cv::Mat img);
    cv::Mat find_ring(cv::Mat img,cv::Rect& rect);


};

#endif // FIND_APRON_H

