#include "ros/ros.h"
#include <std_msgs/String.h>
#include <std_msgs/UInt8.h>
#include "comm_read.h"

int main(int argc, char *argv[])
{
  ros::init(argc, argv, "serialRead");
  ros::NodeHandle nh;

  ros::Publisher loader_state_ret_pub_ = nh.advertise<std_msgs::UInt8>("loader_state_ret", 1);
  autocar::serial_mul::comm_read car_comm_read;
  ros::Rate loopRate(50);
  std_msgs::UInt8 loader_state_ret;
  //set up the serial
  bool sucess = car_comm_read.comm_read::read_setup();
  if (sucess == false)
  {
    perror("error!");
    return -1;
  }
  car_comm_read.read_init();

  while(nh.ok())
  {
    ros::spinOnce();
    loopRate.sleep();
    car_comm_read.read_data();
    loader_state_ret.data=car_comm_read.state_back;
    loader_state_ret_pub_.publish(loader_state_ret);
    printf("state:  %d\n",car_comm_read.state_back);
  }
  return 0;
}
