#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/UInt8.h"
#include "uav_mission/uav_mission_msg.h"
ros::Publisher mission_pub_;
ros::Publisher loader_state_pub_;
ros::Subscriber loader_state_sub_;
ros::Subscriber uav_state_sub_ ;
enum loader_state_{
  UNLOAD,LOADING,LOADED
}loader_state(UNLOAD);
std_msgs::UInt8 loader_state_pubtmp;
uav_mission::uav_mission_msg current_mission;
void loader_state_ret_cb(const std_msgs::UInt8&  loader_state_ret_)
{
  int tmp=loader_state_ret_.data;
  ROS_INFO("rec: %d",tmp);
  if(loader_state==UNLOAD)
  {
    ROS_INFO("1");
    switch(tmp){
      case 0x00:loader_state=UNLOAD;break;
      case 0x3c:loader_state=LOADING;break;
      case 0xc3:loader_state=UNLOAD;break;
      default:loader_state=UNLOAD;break;
      }
    }
   else if(loader_state==LOADING)
  {
      ROS_INFO("2");
      switch(tmp)
      {
          case 0x00:loader_state=LOADED;break;
          case 0x3c:loader_state=LOADING;break;
          case 0xc3:loader_state=UNLOAD;break;
          default:loader_state=LOADING;break;
      }
   }
    else if(loader_state==LOADED)
    {
      ROS_INFO("3");
      switch(tmp)
      {
          case 0x00:loader_state=LOADED;break;
          case 0x3c:loader_state=LOADED;break;
          case 0xc3:loader_state=UNLOAD;break;
          default:loader_state=LOADED;break;
      }
    }
}
void uav_state_cb(const std_msgs::UInt8&  loader_state_ret_) {
}

float takeoff_,flytoo_,h_apron_,f_to_goal_,h_tag_;
void reload(){
    ros::Rate loop_rate(5);
    if(loader_state==UNLOAD)
    while(loader_state!=LOADING)
    {
      loader_state_pubtmp.data=0x3c;
      loader_state_pub_.publish(loader_state_pubtmp);
      ROS_INFO("SEND 60");
      loop_rate.sleep();
      ros::spinOnce();
     }
    while(loader_state!=LOADED)
    {
      ROS_INFO("SEND 00");
      loader_state_pubtmp.data=0x00;
      loader_state_pub_.publish(loader_state_pubtmp);
      loop_rate.sleep();
      ros::spinOnce();
     }
}
void unload(){
    ros::Rate loop_rate(5);
    while(loader_state!=UNLOAD)
    {
      ROS_INFO("SEND 195");
      loader_state_pubtmp.data=0xc3;
      loader_state_pub_.publish(loader_state_pubtmp);
      loop_rate.sleep();
      ros::spinOnce();
    }
    ROS_INFO("unload");
}

int main(int argc, char **argv)
{
  ros::init(argc, argv, "mission_core");
  ros::NodeHandle nh;
  ros::NodeHandle pn("~");


  pn.param<float>("takeoff_", takeoff_, 8);
  pn.param<float>("flytoo_", flytoo_, 3);
  pn.param<float>("h_apron_", h_apron_, 5);
  pn.param<float>("f_to_goal_", f_to_goal_, 4);
  pn.param<float>("h_tag_", h_tag_, 7);

  int temp32;
  mission_pub_        = nh.advertise<uav_mission::uav_mission_msg>("uav_mission_msg",5);
  loader_state_pub_   = nh.advertise<std_msgs::UInt8>("loader_state_set", 1);
  loader_state_sub_   = nh.subscribe("loader_state_ret",1,loader_state_ret_cb);
  uav_state_sub_      = nh.subscribe("/uav_state",1,uav_state_cb);


ROS_INFO("Press any num to start");
      while(!(std::cin >> temp32)){
        std::cin.clear();
        std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
        std::cout << "Invalid input.  Try num: ";
      }
  while (ros::ok())
  {
      
    reload();
//    //LOADED
    ros::Duration(0.1).sleep();
    current_mission.MISSION=current_mission.UAV_TAKEOFF;
    mission_pub_.publish(current_mission);
    mission_pub_.publish(current_mission);
    mission_pub_.publish(current_mission);
    ros::spinOnce();
    ROS_INFO("taking-off");
    ros::Duration(takeoff_).sleep();
    ros::spinOnce();
//    current_mission.MISSION=current_mission.UAV_FLYTOORIGIN;
//    mission_pub_.publish(current_mission);
//    ROS_INFO("fly to origin");
//    ros::Duration(flytoo_).sleep();
   //taking-off
    current_mission.MISSION=current_mission.UAV_HOVER_APRON;
    mission_pub_.publish(current_mission);
    ROS_INFO("hover-apron");
    ros::Duration(h_apron_).sleep();
    ros::spinOnce();
    //hover-apron

    current_mission.MISSION=current_mission.UAV_SET_ORINGIN;
    mission_pub_.publish(current_mission);
    ROS_INFO("set origin");
    ros::Duration(0.1).sleep();
    ros::spinOnce();
    //set origin

    current_mission.MISSION=current_mission.UAV_FLYTOGOAL;
    mission_pub_.publish(current_mission);
    ROS_INFO("fly to goal");
    ros::Duration(f_to_goal_).sleep();
    ros::spinOnce();
    //fly to goal

    current_mission.MISSION=current_mission.UAV_HOVER_TAG;
    mission_pub_.publish(current_mission);
    ROS_INFO("hover tag");
    ros::Duration(h_tag_).sleep();
    ros::spinOnce();
//    //hover-tag
    unload();
    ROS_INFO("unloading ");
    ros::Duration(1).sleep();
    ros::spinOnce();
    //UNLOAD
    current_mission.MISSION=current_mission.UAV_FLYTOHOME;
    mission_pub_.publish(current_mission);
    ros::Duration(5).sleep();
    ROS_INFO("fly to home");
    ros::spinOnce();

    //fly to goal
    current_mission.MISSION=current_mission.UAV_HOVER_APRON;
    mission_pub_.publish(current_mission);
    ROS_INFO("hover apron");
    ros::Duration(6).sleep();
    //hover-apron
    current_mission.MISSION=current_mission.UAV_LANDING;
    mission_pub_.publish(current_mission);
    ROS_INFO("landing");
    ros::Duration(5).sleep();
    ros::spinOnce();
    //LANDING
    current_mission.MISSION=current_mission.UAV_STANDINGBY;
    mission_pub_.publish(current_mission);
    ROS_INFO("standing by");
    ros::Duration(1).sleep();
    ros::spinOnce();
    //loop_rate.sleep();
  }

  return 0;
}
